<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/getrandom-0.2.7/src/util.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>util.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="icon" href="https://www.rust-lang.org/favicon.ico"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../getrandom/index.html"><div class="logo-container"><img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../getrandom/index.html"><div class="logo-container">
                    <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../getrandom/index.html">
                        <img src="https://www.rust-lang.org/logos/rust-logo-128x128-blk.png" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
</pre><pre class="rust"><code><span class="comment">// Copyright 2019 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="kw">use</span> <span class="ident">core::sync::atomic</span>::{<span class="ident">AtomicUsize</span>, <span class="ident">Ordering::Relaxed</span>};

<span class="comment">// This structure represents a lazily initialized static usize value. Useful</span>
<span class="comment">// when it is preferable to just rerun initialization instead of locking.</span>
<span class="comment">// Both unsync_init and sync_init will invoke an init() function until it</span>
<span class="comment">// succeeds, then return the cached value for future calls.</span>
<span class="comment">//</span>
<span class="comment">// Both methods support init() &quot;failing&quot;. If the init() method returns UNINIT,</span>
<span class="comment">// that value will be returned as normal, but will not be cached.</span>
<span class="comment">//</span>
<span class="comment">// Users should only depend on the _value_ returned by init() functions.</span>
<span class="comment">// Specifically, for the following init() function:</span>
<span class="comment">//      fn init() -&gt; usize {</span>
<span class="comment">//          a();</span>
<span class="comment">//          let v = b();</span>
<span class="comment">//          c();</span>
<span class="comment">//          v</span>
<span class="comment">//      }</span>
<span class="comment">// the effects of c() or writes to shared memory will not necessarily be</span>
<span class="comment">// observed and additional synchronization methods with be needed.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">LazyUsize</span>(<span class="ident">AtomicUsize</span>);

<span class="kw">impl</span> <span class="ident">LazyUsize</span> {
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="self">Self</span> {
        <span class="self">Self</span>(<span class="ident">AtomicUsize::new</span>(<span class="ident"><span class="self">Self</span>::UNINIT</span>))
    }

    <span class="comment">// The initialization is not completed.</span>
    <span class="kw">pub</span> <span class="kw">const</span> <span class="ident">UNINIT</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="ident">usize::max_value</span>();

    <span class="comment">// Runs the init() function at least once, returning the value of some run</span>
    <span class="comment">// of init(). Multiple callers can run their init() functions in parallel.</span>
    <span class="comment">// init() should always return the same value, if it succeeds.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">unsync_init</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">init</span>: <span class="kw">impl</span> <span class="ident">FnOnce</span>() -&gt; <span class="ident">usize</span>) -&gt; <span class="ident">usize</span> {
        <span class="comment">// Relaxed ordering is fine, as we only have a single atomic variable.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">val</span> <span class="op">=</span> <span class="self">self</span>.<span class="number">0</span>.<span class="ident">load</span>(<span class="ident">Relaxed</span>);
        <span class="kw">if</span> <span class="ident">val</span> <span class="op">==</span> <span class="ident"><span class="self">Self</span>::UNINIT</span> {
            <span class="ident">val</span> <span class="op">=</span> <span class="ident">init</span>();
            <span class="self">self</span>.<span class="number">0</span>.<span class="ident">store</span>(<span class="ident">val</span>, <span class="ident">Relaxed</span>);
        }
        <span class="ident">val</span>
    }
}

<span class="comment">// Identical to LazyUsize except with bool instead of usize.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">LazyBool</span>(<span class="ident">LazyUsize</span>);

<span class="kw">impl</span> <span class="ident">LazyBool</span> {
    <span class="kw">pub</span> <span class="kw">const</span> <span class="kw">fn</span> <span class="ident">new</span>() -&gt; <span class="self">Self</span> {
        <span class="self">Self</span>(<span class="ident">LazyUsize::new</span>())
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">unsync_init</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">init</span>: <span class="kw">impl</span> <span class="ident">FnOnce</span>() -&gt; <span class="ident">bool</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="number">0</span>.<span class="ident">unsync_init</span>(<span class="op">|</span><span class="op">|</span> <span class="ident">init</span>() <span class="kw">as</span> <span class="ident">usize</span>) <span class="op">!</span><span class="op">=</span> <span class="number">0</span>
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="getrandom" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>